//+------------------------------------------------------------------+
//|                                                  MACD Alert2.mq4 |
//|                                       http://www.trading-team.it |
//+------------------------------------------------------------------+
#property copyright "Silvio Invernici"
#property link      "http://www.trading-team.it"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  clrSilver
#property indicator_color2  clrSilver
#property indicator_color3  clrBlue
#property indicator_color4  clrGreen
#property indicator_color5  clrRed
#property indicator_color6  clrRed
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  2
#property indicator_width4  4
#property indicator_width5  4
#property indicator_width6  4

extern int    FastEMA          = 8;//5 @ Renko
extern int    SlowEMA          = 16;//10
extern int    SignalSMA        = 5;//5
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsNotify     = false;
extern bool   alertsEmail      = false;
extern string soundFile        = "alert2.wav";
extern bool           arrowsVisible              = true;
extern string         arrowsIdentifier           = "macd arrows1";
extern double         arrowsUpperGap             = 1.0;
extern double         arrowsLowerGap             = 1.0;

extern bool           arrowsOnSignalCross        = true;
extern color          arrowsOnSignalCrossUpColor = clrLimeGreen;
extern color          arrowsOnSignalCrossDnColor = clrRed;
extern int            arrowsOnSignalCrossUpCode  = 241;
extern int            arrowsOnSignalCrossDnCode  = 242;
extern int            arrowsOnSignalCrossUpSize  = 2;
extern int            arrowsOnSignalCrossDnSize  = 2;

extern bool           arrowsOnZeroCross          = true;
extern color          arrowsOnZeroCrossUpColor   = clrLimeGreen;
extern color          arrowsOnZeroCrossDnColor   = clrRed;
extern int            arrowsOnZeroCrossUpCode    = 241;
extern int            arrowsOnZeroCrossDnCode    = 242;
extern int            arrowsOnZeroCrossUpSize    = 1;
extern int            arrowsOnZeroCrossDnSize    = 1;


double macd[];
double sign[];
double macdDa[];
double macdDb[];
double macdUp[];
double macdDn[];
double trend[];
double cross[];



int init() 
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,macdUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,macdDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,sign);
   SetIndexBuffer(3,macd);
   SetIndexBuffer(4,macdDa);
   SetIndexBuffer(5,macdDb);
   SetIndexBuffer(6,trend);
   SetIndexBuffer(7,cross);
   IndicatorShortName("MACD Alert2(" + FastEMA + "," + SlowEMA + "," + SignalSMA + ")");
   return (0);
}

int deinit()
{
   deleteArrows();
return(0); 
} 

//+----------------------start---------------------------------------+
int start() 
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
   
   if (trend[limit]==-1) CleanPoint(limit,macdDa,macdDb); 
   for (i=limit; i >= 0; i--) macd[i] = iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i) - iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
   for (i=limit; i >= 0; i--) sign[i] = iMAOnArray(macd,0, SignalSMA, 0, MODE_SMA, i);
   for (i=limit; i >= 0; i--) 
   { 
       macdDa[i] = EMPTY_VALUE;
       macdDb[i] = EMPTY_VALUE;
       macdUp[i] = EMPTY_VALUE;
       macdDn[i] = EMPTY_VALUE;
       trend[i]  = trend[i+1];
       cross[i]  = cross[i+1];
       if (macd[i]>0)       cross[i] = 1;
       if (macd[i]<0)       cross[i] =-1;
       if (macd[i]>sign[i]) trend[i] = 1;
       if (macd[i]<sign[i]) trend[i] =-1;
       if (cross[i] == 1)   macdUp[i] = macd[i];
       if (cross[i] ==-1)   macdDn[i] = macd[i];
       if (trend[i]==-1) PlotPoint(i,macdDa,macdDb,macd);
       
       //
       //
       //
       //
       //
       
       if (arrowsVisible)
        {
           ObjectDelete(arrowsIdentifier+":1:"+Time[i]);
           ObjectDelete(arrowsIdentifier+":2:"+Time[i]);
           string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
           if (arrowsOnSignalCross && trend[i] != trend[i+1])
           {
              if (trend[i] == 1) drawArrow("1",0.5,i,arrowsOnSignalCrossUpColor,arrowsOnSignalCrossUpCode,arrowsOnSignalCrossUpSize,false);
              if (trend[i] ==-1) drawArrow("1",0.5,i,arrowsOnSignalCrossDnColor,arrowsOnSignalCrossDnCode,arrowsOnSignalCrossDnSize,true);
           }
           if (arrowsOnZeroCross && cross[i] != cross[i+1])
           {
             
             if (cross[i] == 1) drawArrow("2",1,i,arrowsOnZeroCrossUpColor,arrowsOnZeroCrossUpCode,arrowsOnZeroCrossUpSize,false);
             if (cross[i] ==-1) drawArrow("2",1,i,arrowsOnZeroCrossDnColor,arrowsOnZeroCrossDnCode,arrowsOnZeroCrossDnSize,true);
              
           }
              
         }       
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      static string   mess1="";
      static datetime time1=0;
      if (cross[whichBar] != cross[whichBar+1])
      if (cross[whichBar] == 1)
            doAlert(mess1,time1,"crossing zero up");
      else  doAlert(mess1,time1,"crossing zero down");       
      static string   mess2="";
      static datetime time2=0;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert(mess2,time2,"crossing signal up");
      else  doAlert(mess2,time2,"crossing signal down");       
   }
return (0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

//--------------------------------------------------------------------------------------+
//
//--------------------------------------------------------------------------------------+
//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," MACD ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," MACD  "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

//
//
//
//
//

void drawArrow(string nameAdd, double gapMul, int i,color theColor,int theCode, int theSize,bool up)
{
   string name = arrowsIdentifier+":"+nameAdd+":"+Time[i];
   double gap  = iATR(NULL,0,20,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theSize);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}
